// DSCAMDEMO.h : main header file for the DICAMDEMO application
//

#if !defined(AFX_DSCAMDEMO_H__F8C2098B_B219_4282_B702_2AFA6E8967FA__INCLUDED_)
#define AFX_DSCAMDEMO_H__F8C2098B_B219_4282_B702_2AFA6E8967FA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include ".\\sdk\DICAMAPI.h"   

////////////////// RESOLUTION SETTINGS DEFINE ///////////////////////////////////////////
#ifdef D1000C
	#define HAVE_SPEED_SUPER    1
	#define MODEL_NAME          "D1000C"
	#define PREVIEW_RESOLUTION  R3664_2748

	#define RESOLUTION_A_INDEX  R3664_2748
	#define RESOLUTION_A_TEXT  "3664*2748"
	#define RESOLUTION_A_ENABLE TRUE

	#define RESOLUTION_B_INDEX  R1600_1200
	#define RESOLUTION_B_TEXT  "1600*1200"
	#define RESOLUTION_B_ENABLE TRUE

	#define RESOLUTION_C_INDEX  R1280_960
	#define RESOLUTION_C_TEXT  "1280*960"
	#define RESOLUTION_C_ENABLE TRUE

	#define RESOLUTION_D_INDEX  R800_600
	#define RESOLUTION_D_TEXT  "800*600"
	#define RESOLUTION_D_ENABLE TRUE

	#define RESOLUTION_E_INDEX  R640_480
	#define RESOLUTION_E_TEXT  "640*480"
	#define RESOLUTION_E_ENABLE TRUE

	#define RESOLUTION_F_INDEX  R_ROI
	#define RESOLUTION_F_TEXT  "ROI"
	#define RESOLUTION_F_ENABLE TRUE

	#define ROI_HOFFSET  320
	#define ROI_VOFFSET  240
	#define ROI_WIDTH    1280
	#define ROI_HEIGHT   1024
#endif

#ifdef D900C
	#define HAVE_SPEED_SUPER    1
	#define MODEL_NAME "D900C"
	#define PREVIEW_RESOLUTION  R1600_1200

	#define RESOLUTION_A_INDEX  R3488_2616
	#define RESOLUTION_A_TEXT  "3488*2616"
	#define RESOLUTION_A_ENABLE TRUE

	#define RESOLUTION_B_INDEX  R1600_1200
	#define RESOLUTION_B_TEXT  "1600*1200"
	#define RESOLUTION_B_ENABLE TRUE

	#define RESOLUTION_C_INDEX  R1280_960
	#define RESOLUTION_C_TEXT  "1280*960"
	#define RESOLUTION_C_ENABLE TRUE

	#define RESOLUTION_D_INDEX  R800_600
	#define RESOLUTION_D_TEXT  "800*600"
	#define RESOLUTION_D_ENABLE TRUE

	#define RESOLUTION_E_INDEX  R640_480
	#define RESOLUTION_E_TEXT  "640*480"
	#define RESOLUTION_E_ENABLE TRUE

	#define RESOLUTION_F_INDEX  R_ROI
	#define RESOLUTION_F_TEXT  "ROI"
	#define RESOLUTION_F_ENABLE TRUE

	#define ROI_HOFFSET  320
	#define ROI_VOFFSET  240
	#define ROI_WIDTH    1280
	#define ROI_HEIGHT   1024
#endif

#ifdef D800C
	#define HAVE_SPEED_SUPER   1
	#define MODEL_NAME         "D800C"
	#define PREVIEW_RESOLUTION  R1600_1200

	#define RESOLUTION_A_INDEX  R3264_2448
	#define RESOLUTION_A_TEXT  "3264*2448"
	#define RESOLUTION_A_ENABLE TRUE

	#define RESOLUTION_B_INDEX  R1600_1200
	#define RESOLUTION_B_TEXT  "1600*1200"
	#define RESOLUTION_B_ENABLE TRUE

	#define RESOLUTION_C_INDEX  R1280_960
	#define RESOLUTION_C_TEXT  "1280*960"
	#define RESOLUTION_C_ENABLE TRUE

	#define RESOLUTION_D_INDEX  R800_600
	#define RESOLUTION_D_TEXT  "800*600"
	#define RESOLUTION_D_ENABLE TRUE

	#define RESOLUTION_E_INDEX  R640_480
	#define RESOLUTION_E_TEXT  "640*480"
	#define RESOLUTION_E_ENABLE TRUE

	#define RESOLUTION_F_INDEX  R_ROI
	#define RESOLUTION_F_TEXT  "ROI"
	#define RESOLUTION_F_ENABLE TRUE

	#define ROI_HOFFSET  320
	#define ROI_VOFFSET  240
	#define ROI_WIDTH    1280
	#define ROI_HEIGHT   1024
#endif

#ifdef D500C
	#define HAVE_SPEED_SUPER  1
	#define MODEL_NAME          "D500C"
	#define PREVIEW_RESOLUTION  R1280_960

	#define RESOLUTION_A_INDEX  R2592_1944
	#define RESOLUTION_A_TEXT  "2592*1944"
	#define RESOLUTION_A_ENABLE TRUE

	#define RESOLUTION_B_INDEX  R1280_960
	#define RESOLUTION_B_TEXT  "1280*960"
	#define RESOLUTION_B_ENABLE TRUE

	#define RESOLUTION_C_INDEX  R1024_768
	#define RESOLUTION_C_TEXT  "1024*768"
	#define RESOLUTION_C_ENABLE TRUE

	#define RESOLUTION_D_INDEX  R640_480
	#define RESOLUTION_D_TEXT  "640*480"
	#define RESOLUTION_D_ENABLE TRUE

	#define RESOLUTION_E_INDEX  R_ROI+1
	#define RESOLUTION_E_TEXT  "Not use"
	#define RESOLUTION_E_ENABLE FALSE

	#define RESOLUTION_F_INDEX  R_ROI
	#define RESOLUTION_F_TEXT  "ROI"
	#define RESOLUTION_F_ENABLE TRUE

	#define ROI_HOFFSET  640
	#define ROI_VOFFSET  480
	#define ROI_WIDTH    1280
	#define ROI_HEIGHT   1024
#endif

#ifdef D300C
	#define MODEL_NAME "D300C"
	#define PREVIEW_RESOLUTION  R1024_768

	#define RESOLUTION_A_INDEX  R2048_1536
	#define RESOLUTION_A_TEXT  "2048*1536"	
	#define RESOLUTION_A_ENABLE TRUE

	#define RESOLUTION_B_INDEX  R1024_768
	#define RESOLUTION_B_TEXT  "1024*768"	
	#define RESOLUTION_B_ENABLE TRUE

	#define RESOLUTION_C_INDEX  R640_480
	#define RESOLUTION_C_TEXT  "640*480"	
	#define RESOLUTION_C_ENABLE TRUE

	#define RESOLUTION_D_INDEX  R_ROI+1
	#define RESOLUTION_D_TEXT  "Not Use"	
	#define RESOLUTION_D_ENABLE FALSE

	#define RESOLUTION_E_INDEX  R_ROI+2
	#define RESOLUTION_E_TEXT  "Not use"
	#define RESOLUTION_E_ENABLE FALSE

	#define RESOLUTION_F_INDEX  R_ROI
	#define RESOLUTION_F_TEXT  "ROI"
	#define RESOLUTION_F_ENABLE TRUE

	#define ROI_HOFFSET  640
	#define ROI_VOFFSET  480
	#define ROI_WIDTH    1024
	#define ROI_HEIGHT   768
#endif

#ifdef DC210C
	#define MODEL_NAME "D210C"
	#define PREVIEW_RESOLUTION  R1024_768

	#define RESOLUTION_A_INDEX  R1600_1200
	#define RESOLUTION_A_TEXT  "1600*1200"	
	#define RESOLUTION_A_ENABLE TRUE

	#define RESOLUTION_B_INDEX  R800_600
	#define RESOLUTION_B_TEXT  "800*600"	
	#define RESOLUTION_B_ENABLE TRUE

	#define RESOLUTION_C_INDEX  R640_480
	#define RESOLUTION_C_TEXT  "640*480"	
	#define RESOLUTION_C_ENABLE TRUE

	#define RESOLUTION_D_INDEX  R_ROI+1
	#define RESOLUTION_D_TEXT  "Not Use"	
	#define RESOLUTION_D_ENABLE FALSE

	#define RESOLUTION_E_INDEX  R_ROI+2
	#define RESOLUTION_E_TEXT  "Not use"
	#define RESOLUTION_E_ENABLE FALSE

	#define RESOLUTION_F_INDEX  R_ROI
	#define RESOLUTION_F_TEXT  "ROI"
	#define RESOLUTION_F_ENABLE TRUE

	#define ROI_HOFFSET  320
	#define ROI_VOFFSET  240
	#define ROI_WIDTH    1024
	#define ROI_HEIGHT   768
#endif

#ifdef D130C
	#define MODEL_NAME "D130C"

	#define PREVIEW_RESOLUTION  R1280_1024

	#define RESOLUTION_A_INDEX  R_ROI+1
	#define RESOLUTION_A_TEXT  "Not use"
	#define RESOLUTION_A_ENABLE FALSE

	#define RESOLUTION_B_INDEX  R1280_1024
	#define RESOLUTION_B_TEXT  "1280*1024"
	#define RESOLUTION_B_ENABLE TRUE

	#define RESOLUTION_C_INDEX  R640_480
	#define RESOLUTION_C_TEXT  "640*480"
	#define RESOLUTION_C_ENABLE TRUE

	#define RESOLUTION_D_INDEX  R320_240
	#define RESOLUTION_D_TEXT  "320*240"
	#define RESOLUTION_D_ENABLE TRUE

	#define RESOLUTION_E_INDEX  R_ROI+2
	#define RESOLUTION_E_TEXT  "Not use"
	#define RESOLUTION_E_ENABLE FALSE

	#define RESOLUTION_F_INDEX  R_ROI
	#define RESOLUTION_F_TEXT  "ROI"
	#define RESOLUTION_F_ENABLE TRUE
	
	#define ROI_HOFFSET  320
	#define ROI_VOFFSET  240
	#define ROI_WIDTH    640
	#define ROI_HEIGHT   480
#endif
#ifdef D036C
	#define MODEL_NAME "D036C"

	#define PREVIEW_RESOLUTION  R752_480

	#define RESOLUTION_A_INDEX  R_ROI+1
	#define RESOLUTION_A_TEXT  "Not use"
	#define RESOLUTION_A_ENABLE FALSE

	#define RESOLUTION_B_INDEX  R752_480
	#define RESOLUTION_B_TEXT  "752*480"
	#define RESOLUTION_B_ENABLE TRUE

	#define RESOLUTION_C_INDEX  R640_480
	#define RESOLUTION_C_TEXT  "640*480"
	#define RESOLUTION_C_ENABLE TRUE

	#define RESOLUTION_D_INDEX  R320_240
	#define RESOLUTION_D_TEXT  "320*240"
	#define RESOLUTION_D_ENABLE TRUE

	#define RESOLUTION_E_INDEX  R_ROI+2
	#define RESOLUTION_E_TEXT  "Not use"
	#define RESOLUTION_E_ENABLE FALSE

	#define RESOLUTION_F_INDEX  R_ROI
	#define RESOLUTION_F_TEXT  "ROI"
	#define RESOLUTION_F_ENABLE FALSE

	#define ROI_HOFFSET  320
	#define ROI_VOFFSET  240
	#define ROI_WIDTH    640
	#define ROI_HEIGHT   480

#endif
/////////////////////////////////////////////////////////////////////////////
// CDSCAMDEMOApp:
// See DSCAMDEMO.cpp for the implementation of this class
//

class CDSCAMDEMOApp : public CWinApp
{
public:
	CDSCAMDEMOApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDSCAMDEMOApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CDSCAMDEMOApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	HANDLE myMutex;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DSCAMDEMO_H__F8C2098B_B219_4282_B702_2AFA6E8967FA__INCLUDED_)
