// DICAMDEMODlg.cpp : implementation file
//

#include "stdafx.h"
#include "DICAMDEMODlg.h"
#include "Setup.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//#define ENABLE_READ_SN_DEBUG

const UINT WM_USERDEFMSG = ::RegisterWindowMessage(_T("UserDefMsg"));

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDSCAMDEMODlg dialog

CDSCAMDEMODlg::CDSCAMDEMODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDSCAMDEMODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDSCAMDEMODlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	
	m_HOff = 0;
	m_VOff = 0;
	m_Width = 0;	
	m_Height = 0;
	m_FileType = 0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDSCAMDEMODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDSCAMDEMODlg)
	DDX_Control(pDX, IDC_MULTICAM_LIST, m_MultiCamList);
	//}}AFX_DATA_MAP
}
/////////////////////////////////////////////////////////////////////////////
// CDSCAMDEMODlg message handlers
BEGIN_MESSAGE_MAP(CDSCAMDEMODlg, CDialog)
	//{{AFX_MSG_MAP(CDSCAMDEMODlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_SAVEFILE, OnSavefile)
	ON_BN_CLICKED(IDC_SETUP, OnSetup)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_MESSAGE(WM_DEL_SETUP_DLG,OnDelSetupDlgMsg)
	ON_MESSAGE(WM_DEL_SETRESOLUTION_DLG,OnDelSetResolutionMsg)
	ON_BN_CLICKED(IDC_RESOLUTION, OnResolution)
	ON_REGISTERED_MESSAGE(WM_USERDEFMSG, OnVideoMsg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//ûṩSDKʹã
//ûڻصʵֶԲɼݵĴ
//pBuffer is RGB24BIT DATA 
//here is GBGB....RGRG....
#define B_OFFSET    0
#define G_OFFSET    1
#define R_OFFSET    2
/*==============================================================
:	SnapThreadCallback
:   ṩSDKʹõĺ.
:   *pBuffer ǰ֡ͼָ. 
        Type-- DATA_TYPE_RAW ͼԭʼ˽ݴСΪImageWidth*ImageHeight*BYTE
		    -- DATA_TYPE_RGB24  RGB24, ݴСΪImageWidth*ImageHeight*3
		LPVOID lpContext Ĺϵ
	

ֵ: 
˵: ûڴ˺бдԼĳͼ,Ƶȵ

	ͼлһ.
ע⣺1һ֡ȷͼصЩΣһType = DATA_TYPE_RAW,ڶDATA_TYPE_RGB24Ҫѡȷݡ
      2뾡ٴ˺ռʱ䣬ͼCAPYBUFFERٴô˺緵ء
--------------------------------------------------------------*/
int CALLBACK SnapThreadCallback(BYTE *pBuffer,  DI_DATA_TYPE Type, LPVOID lpContext)
{
	CDSCAMDEMODlg *pCtrl = (CDSCAMDEMODlg *)lpContext;
	pCtrl->ImageProcess(pBuffer, Type);
	return TRUE;	
	
#if 0
	/* ɼIO3׳̬IO2 */
	BYTE m_led = 0;
	//  io3 input, io2 output
	CameraSetGpio(0x02); 
	
	CameraReadGpio(&m_led);
	if ( m_led & 0x01 )
	{
		CameraWriteGpio(0x02);
	}
	else
	{
		CameraWriteGpio(0x00);
	}
#endif
	return TRUE;
}

BOOL CDSCAMDEMODlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	m_HOff = ROI_HOFFSET;
	m_VOff = ROI_VOFFSET;
	m_Width = ROI_WIDTH;	
	m_Height = ROI_HEIGHT;

	m_FileType = FILE_JPG;

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	GetDlgItem(IDC_SETUP)->EnableWindow(FALSE);
	GetDlgItem(IDC_RESOLUTION)->EnableWindow(TRUE);
	GetDlgItem(IDC_SAVEFILE)->EnableWindow(FALSE);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	//parameter init. set window size and position.
	BYTE CamAllNum = 0;
	BYTE Resolution = 0;
	BYTE CapRes = 0;
	CameraGetMultiCameraNumber(&CamAllNum, &Resolution, &CapRes);
	for(int i=0; i<CamAllNum; i++)
	{
		CString xtmp;
		xtmp.Format("%s #%d", MODEL_NAME,i+1);
		m_MultiCamList.AddString(xtmp);
	}
	m_MultiCamList.SetCurSel(0);

	m_SetupDlg = NULL;
	m_SetResolutionDlg = NULL;
	m_Resolution = (DI_RESOLUTION)Resolution;
	m_CaptureResolution = (DI_RESOLUTION)CapRes;
	SetMainWindowText();
	SetDisplayWindow();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDSCAMDEMODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CDSCAMDEMODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDSCAMDEMODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDSCAMDEMODlg::OnPlay() 
{
	// TODO: Add your control notification handler code here
	if (m_RunMode == RUNMODE_PLAY)
	{
		CameraStop();
		CameraUnInit();
		SetDlgItemText(IDC_PLAY, "&Play");
		GetDlgItem(IDC_PLAY)->SetFocus();
		GetDlgItem(IDC_SAVEFILE)->EnableWindow(FALSE);
		GetDlgItem(IDC_SETUP)->EnableWindow(FALSE);
		GetDlgItem(IDC_RESOLUTION)->EnableWindow(TRUE);
		m_RunMode = RUNMODE_STOP;
	}
	else  
	{
		BYTE CamNum = m_MultiCamList.GetCurSel();
		if (m_MultiCamList.GetCount() == 0)
		{
			CamNum = 0;
		}
		if (R_ROI == m_Resolution)
		{
			CameraSetROI(m_HOff, m_VOff, m_Width, m_Height);
		}
		if (STATUS_OK != CameraInit(SnapThreadCallback, 
									m_Resolution,
									GetDlgItem(IDC_VIDEO)->m_hWnd, //NULL,//
									CamNum+1,
									this->m_hWnd,
									this) )
		{
			MessageBox("Init Camera failed", "Error", MB_OK | MB_ICONSTOP);
			return ;
		}

#ifdef ENABLE_READ_SN_DEBUG
		char SN[32];
		CameraReadSN(SN, 32);
		CString sSN;
		sSN = SN;
		
		CString sUserSN = "WWW.D-IMAGE.NET 0755-61860636";
		if (sSN == sUserSN)
		{
		//	MessageBox(x, "SN is OK!", MB_OK | MB_ICONSTOP);
		}
		else //鲻ԣдһΣд֮ǰȷEEPROMڿд״̬
		{
			char* pAddr = sUserSN.GetBuffer(32);
			
			CameraWriteSN(pAddr, 32);

			char cNewSn[32];
			CameraReadSN(cNewSn, 32);
			CString sNewSN = cNewSn;

			if (sNewSN == sUserSN )
			{		
				MessageBox("SN Rewrite Ok!", "SN Error", MB_OK | MB_ICONSTOP);
			}
			else
			{
				MessageBox("SN Rewrite Error!", "SN Error", MB_OK | MB_ICONSTOP);
			}
			CameraUnInit();
			return;
		}
#endif
		//set AWB window
		{
			INT width = 0;
            INT hight = 0;
			CameraGetImageSize(&width, &hight);
			CameraSetWBWindow(width>>2, hight>>2, width>>1, hight>>1);
		}
		SetDlgItemText(IDC_PLAY, "Sto&p");
		GetDlgItem(IDC_SAVEFILE)->EnableWindow(TRUE);
		GetDlgItem(IDC_SETUP)->EnableWindow(TRUE);
		GetDlgItem(IDC_RESOLUTION)->EnableWindow(TRUE);

		CameraSetVideoMessage(WM_USERDEFMSG);
		SetDisplayWindow();	

		CameraPlay(); 
		m_iVideoCnt = 0;
	    m_iErrorFrames = 0;
		m_RunMode = RUNMODE_PLAY;
		SetMainWindowText();
	}
	GetDlgItem(IDC_VIDEO)->UpdateWindow();	
}

void CDSCAMDEMODlg::OnSavefile() 
{
	// TODO: Add your control notification handler code here
	//set the save file name and path...
	//the default here is exe file path...
	//You can change here..

		CTime time = CTime::GetCurrentTime();
		CString sPath ;
		GetModuleFileName(NULL, sPath.GetBuffer(256), 256);
		sPath.ReleaseBuffer(256);
		int nPos = sPath.ReverseFind('\\');
		sPath = sPath.Left(nPos + 1);
		
		CString sfilename ; 
		sfilename.Format("%sP%02d%02d%02d%02d%02d", sPath, time.GetMonth(), time.GetDay(), 
			time.GetHour(), time.GetMinute(), time.GetSecond());
		
#if 0
	int Width = 0;
	int Height= 0;
	if (STATUS_OK == CameraGetImageSize(&Width, &Height))
	{
		int nImageSize = Width*Height;
		BYTE* BmpBuffer   = (BYTE *) malloc(nImageSize * 3 + 512);
		
		if (BmpBuffer != NULL)
		{	
			CameraCaptureToBuf(BmpBuffer, DATA_TYPE_RGB24);		
			SaveBmpFile(sfilename,BmpBuffer,Width,Height);
		}
		free(BmpBuffer);
		BmpBuffer = NULL;
	}
	//	CameraEnableDeadPixelCorrection();
	//	CameraSetDisplayWindow(160,120,320,240);
#else
	if (R_ROI == m_CaptureResolution)
	{
		CameraSetROI(m_HOff, m_VOff, m_Width, m_Height);
	}//
	CameraCaptureFile(sfilename, m_FileType, 90, m_CaptureResolution);
#endif
}

void CDSCAMDEMODlg::OnSetup() 
{
	// TODO: Add your control notification handler code here
	if (m_SetupDlg != NULL)
	{
		delete m_SetupDlg;
		m_SetupDlg = NULL;
		return;
	}
	
	m_SetupDlg = new CSetup(this);

	m_SetupDlg->m_FTypeIndex = m_FileType;
	m_SetupDlg->Create(IDD_SETUP_DIALOG, this);
	m_SetupDlg->ShowWindow(SW_SHOW);
}

//////////////////////////////////////////////////////////////////////////
// del the setup dialog...
//
//////////////////////////////////////////////////////////////////////////
LONG CDSCAMDEMODlg::OnDelSetupDlgMsg(WPARAM wP, LPARAM lP)
{
	BYTE TempIndex;
	TempIndex = m_SetupDlg->m_FTypeIndex;

// 	if (lP == 1)
// 	{
// 		m_FileType = TempIndex;
// 		this->UpdateWindow();
// 		return 0;
// 	}

	if (m_SetupDlg != NULL)
	{
		delete m_SetupDlg;
		m_SetupDlg = NULL;
	}

	m_FileType = TempIndex;
	this->UpdateWindow();
	return 0;
}

LONG CDSCAMDEMODlg::OnDelSetResolutionMsg(WPARAM wP, LPARAM lP)
{
	BYTE TempIndex;
	int  TempHOff;
	int  TempVOff;
	int  TempWidth;
	int  TempHeight;

	BYTE TempCIndex;

    TempIndex = m_SetResolutionDlg->m_RSLTIndex;
	TempHOff = m_SetResolutionDlg->m_HOff;
    TempVOff = m_SetResolutionDlg->m_VOff;
	TempWidth = m_SetResolutionDlg->m_Width;
 	TempHeight = m_SetResolutionDlg->m_Height;

	TempCIndex = m_SetResolutionDlg->m_CaptureIndex;


	if (m_SetResolutionDlg != NULL)
	{
		delete m_SetResolutionDlg;
		m_SetResolutionDlg = NULL;
	}
	if (lP == 0)
	{
		return 0;
	}

	m_CaptureResolution = (DI_RESOLUTION)TempCIndex;

	if (TempIndex != R_ROI)
 	{
		if ((DI_RESOLUTION)TempIndex == m_Resolution)
		{
			return 0;
		}
	}

	m_Resolution = (DI_RESOLUTION)TempIndex;
	m_HOff = TempHOff;
	m_VOff = TempVOff;
	m_Width = TempWidth;
 	m_Height = TempHeight;

	m_CaptureResolution = (DI_RESOLUTION)TempCIndex;

	if (m_RunMode == RUNMODE_PLAY)
	{
		OnPlay();	
		Sleep(100);
		OnPlay();
	}
	this->UpdateWindow();
	return 0;
}


void CDSCAMDEMODlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	CameraStop();
	CameraUnInit();
	OnClose();
	CDialog::OnOK();	
}

/*
	int Width = 0;
	int Height= 0;
	if (STATUS_OK != CameraGetImageSize(&Width, &Height))
	{
		return FALSE;
	}
	BYTE* pBuffer   = (BYTE *) malloc( Width* Height * 4);
	CameraSnap(pBuffer, DATA_TYPE_RGB24);
*/
void CDSCAMDEMODlg::SetDisplayWindow()
{
	int x0 = 0;
	int y0 = 0;
	int nWinWidth =0;
	int nWinHeight=0;
	
	int iFullScrn_cx = GetSystemMetrics(SM_CXSCREEN);
	int iFullScrn_cy = GetSystemMetrics(SM_CYSCREEN);
	int iCAPTION     = GetSystemMetrics(SM_CYCAPTION);
	
	int Width = 0;
	int Height= 0;
	if (STATUS_OK != CameraGetImageSize(&Width, &Height))
	{
		Width = 640;
		Height= 480;	
	}
	if (Width < (iFullScrn_cx-48) )
	{
		if(Width < 640)
		{
			nWinWidth = 640;
			nWinHeight = 480;
			x0 = 0;
			y0 = 0;
		}
		else
		{
			nWinWidth = Width+3;
			nWinHeight = Height+48;
			x0 = (iFullScrn_cx - Width)>>1;
			y0 = (iFullScrn_cy - Height - 48)>>1;
		}
	}
	else
	{
		x0 = 0;
		y0 = 0;
		nWinWidth = iFullScrn_cx;
		nWinHeight = iFullScrn_cy;
		Width = iFullScrn_cx - 4;
		Height = iFullScrn_cy - 36;
	}
	x0 = max(0, x0);
	y0 = max(0, y0);
	GetDlgItem(IDC_VIDEO)->SetWindowPos(NULL, 0,25, Width,Height,
		SWP_NOZORDER | SWP_SHOWWINDOW);
	this->SetWindowPos(NULL, 0,0, nWinWidth,nWinHeight,
		SWP_NOZORDER | SWP_SHOWWINDOW);
	
	const int width = 70;
	const int height = 24;
	const int interval = width+2;
	int i = 0;
	GetDlgItem(IDC_PLAY)->SetWindowPos(NULL,interval*(i++),0,width,height,SWP_NOZORDER | SWP_SHOWWINDOW);	
	GetDlgItem(IDC_SAVEFILE)->SetWindowPos(NULL,interval*(i++),0,width,height,SWP_NOZORDER | SWP_SHOWWINDOW);
	GetDlgItem(IDC_SETUP)->SetWindowPos(NULL,interval*(i++),0,width,height,SWP_NOZORDER | SWP_SHOWWINDOW);
	GetDlgItem(IDC_RESOLUTION)->SetWindowPos(NULL,interval*(i++),0,width,height,SWP_NOZORDER | SWP_SHOWWINDOW);
	GetDlgItem(IDC_EXIT)->SetWindowPos(NULL,interval*(i++),0,width,height,SWP_NOZORDER | SWP_SHOWWINDOW);
	i++;
	GetDlgItem(IDC_MULTICAM_LIST)->SetWindowPos(NULL,interval*(i++)+20,2,120,height*3,SWP_NOZORDER | SWP_SHOWWINDOW);
}

void CDSCAMDEMODlg::SetMainWindowText()
{
	CString text ;
	text.Format(MODEL_NAME);
	this->SetWindowText(text);
}

void CDSCAMDEMODlg::OnResolution() 
{
	// TODO: Add your control notification handler code here
	if (m_SetResolutionDlg != NULL)
	{
		delete m_SetResolutionDlg;
		m_SetResolutionDlg = NULL;
		return;
	}
	
	m_SetResolutionDlg = new CSetResolution(this);
	m_SetResolutionDlg->m_RSLTIndex = m_Resolution;
	m_SetResolutionDlg->m_HOff = m_HOff;
	m_SetResolutionDlg->m_VOff = m_VOff;
	m_SetResolutionDlg->m_Width = m_Width;	
	m_SetResolutionDlg->m_Height = m_Height;

	m_SetResolutionDlg->m_CaptureIndex = m_CaptureResolution;
	m_SetResolutionDlg->Create(IDD_RESOLUTION_DIALOG, this);
	m_SetResolutionDlg->ShowWindow(SW_SHOW);
	UpdateData(FALSE);
}

LONG CDSCAMDEMODlg::OnVideoMsg(WPARAM wP, LPARAM lP)
{
	if (CAMERA_MSG_VIDEO == wP )
	{
		if (lP == STATUS_OK )
		{		
// 			m_iVideoCnt++;
// 			CString text;
//  			float fps;
// 			CameraGetFPS(&fps);
// 			text.Format("%.2fps!", fps);
//   			this->SetWindowText(text);
		}
		else if (lP == STATUS_INTERNAL_ERROR )
		{
			m_iErrorFrames++;
// 			CString text ;
// 			text.Format("%d frames error!", m_iErrorFrames);
// 			this->SetWindowText(text);
		}
		else
		{
			CString text ;
			text.Format("Device error! Restart...");
			this->SetWindowText(text);
			OnPlay();	
			Sleep(100);
			OnPlay();
		}
	}
	
	return 0;
}

VOID CDSCAMDEMODlg::ImageProcess(BYTE *pBuffer, DI_DATA_TYPE Type)
{
	if (Type == DATA_TYPE_RAW)
	{

	}
	if (Type == DATA_TYPE_RGB24)
	{
#if 0   //һ
		//pBuffer is RGB24BIT DATA 
		
		int Width = 0;
		int Height= 0;
		if (STATUS_OK != CameraGetImageSize(&Width, &Height))
		{
			return FALSE;	
		}
		for (int i= 100; i<=101; i++)
		{
			for (int j=0; j<Width; j++)
			{
				*(pBuffer+(i*Width+j)*3+B_OFFSET) = 0x00;
				*(pBuffer+(i*Width+j)*3+G_OFFSET) = 0x00;
				*(pBuffer+(i*Width+j)*3+R_OFFSET) = 0xff;
			}
		}
#endif
	}
}
