// DICAMDEMODlg.h : header file
//

#if !defined(AFX_DSCAMDEMODLG_H__60E16ECA_5A4A_4976_8EEA_C7F16D52522B__INCLUDED_)
#define AFX_DSCAMDEMODLG_H__60E16ECA_5A4A_4976_8EEA_C7F16D52522B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "DICAMDEMO.h"
#include "Setup.h"
#include "SetResolution.h"

/////////////////////////////////////////////////////////////////////////////
// CDSCAMDEMODlg dialog

class CDSCAMDEMODlg : public CDialog
{
// Construction
public:
	VOID ImageProcess(BYTE *pBuffer, DI_DATA_TYPE Type);

	CDSCAMDEMODlg(CWnd* pParent = NULL);	// standard constructor
	BYTE m_RunMode;
	CSetup*   m_SetupDlg;//Setup dialog. AE/AWB/Saturation/Contrast/Gamma
	CSetResolution* m_SetResolutionDlg;
// Dialog Data
	//{{AFX_DATA(CDSCAMDEMODlg)
	enum { IDD = IDD_DSCAMDEMO_DIALOG };
	CComboBox	m_MultiCamList;
	CComboBox	m_ResList;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDSCAMDEMODlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	int m_Height;
	int m_Width;
	int m_VOff;
	int m_HOff;
	BYTE m_FileType;//index of file type
	
	void SetDisplayWindow();
	// Generated message map functions
	//{{AFX_MSG(CDSCAMDEMODlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPlay();
	afx_msg void OnSavefile();
	afx_msg void OnSetup();
	afx_msg void OnExit();
	afx_msg LONG OnDelSetupDlgMsg(WPARAM wP, LPARAM lP);
	afx_msg LONG OnDelSetResolutionMsg(WPARAM wP, LPARAM lP);
	afx_msg void OnResolution();
	afx_msg LONG OnVideoMsg(WPARAM wP, LPARAM lP);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	DI_RESOLUTION m_CaptureResolution;

	DI_RESOLUTION m_Resolution;
	UINT m_iVideoCnt;
	UINT m_iErrorFrames;
	void SetMainWindowText();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DSCAMDEMODLG_H__60E16ECA_5A4A_4976_8EEA_C7F16D52522B__INCLUDED_)
