#if !defined(AFX_SETUP_H__02A68727_300E_4EA0_803E_0E55CC424F1E__INCLUDED_)
#define AFX_SETUP_H__02A68727_300E_4EA0_803E_0E55CC424F1E__INCLUDED_

#include "./sdk/DICAMAPI.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Setup.h : header file
//
#define WM_DEL_SETUP_DLG		WM_USER+ 0X33
/////////////////////////////////////////////////////////////////////////////
// CSetup dialog

class CSetup : public CDialog
{
// Construction
public:
	void UpdateSetupWindow();
	CSetup(CWnd* pParent = NULL);   // standard constructor
	CWnd*   m_pParent;
// Dialog Data
	//{{AFX_DATA(CSetup)
	enum { IDD = IDD_SETUP_DIALOG };
	CSliderCtrl	m_SaturationCtrl;
	CSliderCtrl	m_RGainCtrl;
	CSliderCtrl	m_GGainCtrl;
	CSliderCtrl	m_GammaCtrl;
	CSliderCtrl	m_AnalogGainCtrl;
	CSliderCtrl	m_ExpTimeCtrl;
	CSliderCtrl	m_ContrastCtrl;
	CSliderCtrl	m_BGainCtrl;
	CSliderCtrl	m_AeTargetCtrl;
	BOOL	m_Aeen;
	int		m_AeTarget;
	int		m_BGain;
	BOOL	m_bColorCorrect;
	int		m_Contrast;
	int		m_ExpTime;
	int		m_AnalogGain;
	int		m_Gamma;
	int		m_GGain;
	int		m_RGain;
	int		m_Saturation;
	int		m_FrameSpeed;
	BOOL	m_bMono;
	BOOL	m_bHFlip;
	BOOL	m_bVFlip;
	BOOL	m_CheckBMP;
	BOOL	m_CheckJPG;
	BOOL	m_CheckRAW;
	BYTE	m_FTypeIndex;
	BOOL	m_CheckPNG;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetup)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	//}}AFX_VIRTUAL

// Implementation
protected:
	
	void UpdateColorGain();

	// Generated message map functions
	//{{AFX_MSG(CSetup)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnAwbone();
	afx_msg void OnClose();
	afx_msg void OnCustomdrawAetarget(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawBgain(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawContrast(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawExptime(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawGain(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawGamma(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawGgain(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawRgain(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawSaturation(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColorcorrect();
	afx_msg void OnAeen();
	afx_msg void OnLowspeed();
	afx_msg void OnHighspeed();
	afx_msg void OnLf50hz();
	afx_msg void OnLf60hz();
	afx_msg void OnPta();
	afx_msg void OnPtb();
	afx_msg void OnPtc();
	afx_msg void OnPtd();
	afx_msg void OnSaveParameter();
	afx_msg void OnHfip();
	afx_msg void OnVflip();
	afx_msg void OnMono();
	afx_msg void OnCheckJPG();
	afx_msg void OnCheckBMP();
	afx_msg void OnCheckRAW();
	afx_msg void OnB2rgbA();
	afx_msg void OnB2rgbB();
	afx_msg void OnB2rgbC();
	afx_msg void OnLoadParameter();
	afx_msg void OnSuperspeed();
	afx_msg void OnCheckpng();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void UpdateExposurteTimeText();
	void SetDisplayWindow();
	DI_PARAMETER_TEAM m_ParameterTeam;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUP_H__02A68727_300E_4EA0_803E_0E55CC424F1E__INCLUDED_)
